
	function random_ore()
		local n = love.math.random(100)
		if n<46 then return {"iron","raw"}
		elseif n<91 then return {"copper","raw"}
		elseif n<95 then return {"tin","bar"}
		elseif n<99 then return {"bronze","bar"}
		elseif n==99 then return {"R_iron","bar"}
		else return {"R_copper","bar"} end
	end

	next=random_ore()


function pokebox(x,y,with)
	if grid[x][y][2] == "none" then
		grid[x][y]=next

		combinecheck(x,y,next[2])
		next=random_ore()
	end

end



function combinecheck(x,y,tier)

	
	function clean_table(tier)
		if tier == "raw" then return {iron=0,copper=0,trash=0} end
		if tier == "bar" then return {R_iron=0,R_copper=0,mixed=0,bronze=0,tin=0}end
		if tier == "heavy" then return {P_iron=0,P_copper=0,obsid=0} end
		if tier == "fancy" then return {gold=0,silver=0,F_gold=0,steel=0,damas=0,meteor=0} end
		if tier == "end" then return "error" end
	end

	local combine_table = clean_table(tier)

	function touchingcheck(xx,yy,f)
		if grid[xx][yy][2]==tier and tier ~= "end" then
			f(xx,yy)
			--------
			if (not (x == xx+1 and y== yy  ) and grid[xx+1][yy  ][2]==tier) then f(xx+1,yy  ) end
			if (not (x == xx-1 and y== yy  ) and grid[xx-1][yy  ][2]==tier) then f(xx-1,yy  ) end
			if (not (x == xx   and y== yy+1) and grid[xx  ][yy+1][2]==tier) then f(xx  ,yy+1) end
			if (not (x == xx   and y== yy-1) and grid[xx  ][yy-1][2]==tier) then f(xx  ,yy-1) end
		end
	end

	touchingcount = 0
	function count(xx,yy)
		touchingcount = touchingcount + 1
	end

	local combine_pos = 2

	function zero(xx,yy)
		type=grid[xx][yy][1]
		combine_table[type]=combine_table[type] + 1
		grid[xx][yy]= {"error","none"}
	end


	touchingcheck(x+1,y  ,count)
	touchingcheck(x-1,y  ,count)
	touchingcheck(x  ,y+1,count)
	touchingcheck(x  ,y-1,count)
	
	--print(touchingcount)
	------

	if (touchingcount >= 2) then

		touchingcheck(x+1,y  ,zero)
		touchingcheck(x-1,y  ,zero)
		touchingcheck(x  ,y+1,zero)
		touchingcheck(x  ,y-1,zero)

		zero(x,y)

		--combine_table = table.sort(combine_table)

		function tier_matcher(tier)
			if tier == "raw" then return raw_matcher(combine_table) end
			if tier == "bar" then return bar_matcher(combine_table) end
			if tier == "heavy" then return heavy_matcher(combine_table) end
			if tier == "fancy" then return fancy_matcher(combine_table) end
			if tier == "end" then return "error" end
		end
		print(tier,combine_table)
		grid[x][y]= tier_matcher(tier)
		print(grid[x][y][1])
		print(grid[x][y][2])
		--print(combine_table["iron"])
		combinecheck(x,y,grid[x][y][2])
	end
end


function score()
	local count={iron=0,copper=0,trash=0,P_iron=0,P_copper=0,obsid=0,
				R_iron=0,R_copper=0,mixed=0,bronze=0,tin=0,gold=0,
				silver=0,F_gold=0,steel=0,damas=0,meteor=0,myth=0,
				W_gold=0,etherial=0,D_steel=0,     error=0}


	for i=1,gridsize.x do
		for j=1,gridsize.y do
			local name= grid[i][j][1]
			count[name]=count[name]+1
		end
	end

	local score = 0

	local function add(x)
		score = score + x
	end

	if count["myth"]>1 then add(3000) end
	if count["W_gold"]>1 then add(3000) end
	if count["etherial"]>1 then add(3000) end
	if count["D_steel"]>1 then add(3000) end

	local function e(name)
		if count[name] > 0 then return true else return false end
	end

	if e("myth") and e("W_gold") and e("etherial") and e("D_steel") then add(10000) end

	add(  (count["myth"]+count["W_gold"]+count["etherial"]+count["D_steel"])*500  )

	add(  (count["gold"]*3+count["silver"]+count["F_gold"]*.5)*100   )

	add(  (count["steel"]+count["damas"]*2)*70   )

	add(  (count["meteor"]*2+count["obsid"])*45  )

	add(  (count["P_iron"]+count["P_copper"])*50 )

	add(  (count["R_iron"]+count["R_copper"]+count["mixed"]*2)*20    )

	add(  (count["bronze"]+count["tin"])*5       )

	add(  (count["iron"]+count["copper"]  -  count["trash"])*1         )

	return score
end











---------------


function love.load()
    grid = {}
    gridsize = {x=12,y=7}
    for i=0,gridsize.x+1 do
    	grid[i]={}
    	for j=0,gridsize.y+1 do  -- todo? make proper edge checking?
    		grid[i][j]={"error","none"}
    	end
    end
    boxsize = {x=128,y=128}
    love.filesystem.load("ore_combo.lua")()
    love.filesystem.load("draw_functions.lua")()
    love.window.setFullscreen(true, "desktop")
end
 

function love.update(dt)

end

function love.mousepressed(x, y, button, istouch)
 -- Versions prior to 0.10.0 use the MouseConstant 'l'
      pokebox(
      	math.ceil(x/boxsize.x),
      	math.ceil(y/boxsize.y),
      	button)

end

function love.keypressed(key,a,b)
	if key=="1" then
		for i=1,100 do
			pokebox(love.math.random(gridsize.x),love.math.random(gridsize.y))
		end
	end
end



-------

function graphics_table(string)
	-- body
end

function num(x)
	if x then return 1 else return 0 end
end

function drawbox(x,y)
	local tier=grid[x][y][2]
	if not (tier == "none") then 
		draw_ore((x-1)*boxsize.x,(y-1)*boxsize.y,grid[x][y][1]) end
	--[[love.graphics.setColor(
		num(tier == 0),
		num(tier == 1),
		num(tier == 2))]]
	love.graphics.print(grid[x][y][1],(x-1)*boxsize.x+12,(y-1)*boxsize.y,1)
end


 

function love.draw()
	--- draw grid
	love.graphics.setColor(1,1,1)
	for i=0,gridsize.x do
		love.graphics.line(i*boxsize.x,0,i*boxsize.x,gridsize.y*boxsize.y)
	end
	for i=0,gridsize.y do
		love.graphics.line(0,i*boxsize.y,gridsize.x*boxsize.x,i*boxsize.y)
	end

	--draw_ore(0,0,"iron")
--- draw boxes
	for i=1,gridsize.x do
		for j=1,gridsize.y do
			drawbox(i,j)
		end

	end

	draw_ore(1600,64,next[1])
	love.graphics.print("score: "..score(), 1600,230,0,3,3)
end